/*
 * sbug.h - Debugger functions
 *
 * Written 2003 by Werner Almesberger, Caltech Netlab FAST project
 */

#ifndef SBUG_H
#define SBUG_H

#include "dwarfx.h"
#include "ptrace.h"

#include "data.h"
#include "op.h"
#include "stmt.h"


extern int sbug;


struct object;


/* ----- data.h ------------------------------------------------------------ */


extern struct dwx_type proc_type;
extern struct dwx_type object_type;

struct value *proc_value(struct pt_process *proc);
struct pt_process *value_proc(struct value *value);
struct pt_process *proc_eval(const struct op *op);

struct value *object_value(struct object *obj);
const struct object *value_object(struct value *value);
const struct object *object_eval(const struct op *op);


/* ----- op.h -------------------------------------------------------------- */


struct value *op_object(const struct op *self);


/* ----- stmt.h ------------------------------------------------------------ */


void stmt_continue(const struct stmt *self);
void stmt_breakpoint(const struct stmt *self);
void stmt_delete(const struct stmt *self);

int destroy_sbug_stmt(const struct stmt *stmt);


/* ----- Data access ------------------------------------------------------- */


struct value *dereference_object(struct value *value);


/* ----- Other functions --------------------------------------------------- */

int sbug_main(int argc,char **argv);
void launch_subprocess(char **argv);

#endif /* SBUG_H */
